﻿package 
{
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.net.*;
	import flash.filters.*;
		
	public class Verdeter extends Sprite
	{
		private var i:Number;
		private var o:Object;
		private var b:BitmapData;
		private var toCopy:BitmapData;
		private var loader:Loader;
		private var brightness:Number;
		private var pixel:uint;
		private var img:Bitmap;
		
		private var speed:Number;
		private var radians:Number;
		private var angle:Number;
		
		private var offsets:				Array		= [];
		private var offsetSpeed1:			Number		= 2.0;
		private var offsetSpeed2:			Number		= -2.0;
		private var noiseBMD:				BitmapData;
		private var noiseBMP:				Bitmap;
		private var baseX:					int			= 800;
		private var baseY:					int			= 800;
		private var noiseSeed:				int			= 100;
		private var pixelDirect:			uint;
		private var margin:					Number		= 2;
		
		
		private var imgRastretize:Array=new Array(
											   
											   "data/1232045463_1-web.jpg",
											   "data/black.jpg",
											   "data/paok.jpg",
											   "data/BR13D00Z.jpg",
											   "data/federal-reserve-seal.jpg",
											   "data/guinness_labelposter.jpg"
											   
											   );
		
		public function Verdeter()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			offsets.push( new Point() );
			offsets.push( new Point() );
			noiseSeed = Math.random() * 2000 << 0;
			
			noiseBMD = new BitmapData( stage.stageWidth, stage.stageHeight,true);
			noiseBMP = new Bitmap( noiseBMD );
			//noiseBMP.visible = true;
			//addChild(noiseBMP);
			
			loadImage();
			addEventListener(MouseEvent.MOUSE_DOWN, DownHandler);
		}
		
		private function loadImage():void {
			
			loader = new Loader();
			var urlRequest:URLRequest=new URLRequest(imgRastretize[Math.floor(Math.random()*imgRastretize.length)]);
			loader.load(urlRequest);	
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, imageLoaded);
		}
		
		private function imageLoaded(e:Event)
		{
			toCopy = new BitmapData(stage.stageWidth,stage.stageHeight,false)
			toCopy.draw(loader)
			
			addEventListener(Event.ENTER_FRAME, enterHandler);
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			o = new Object();
			b = new BitmapData(stage.stageWidth,stage.stageHeight,true,0x0ff000);
			img = new Bitmap(b);
			img.smoothing = true;
			addChild(img);
		}
		
		private function DownHandler(e:Event):void
		{
			graphics.clear();
			removeEventListener(Event.ENTER_FRAME,enterHandler);
			var rect:Rectangle=new Rectangle(0,0,stage.stageWidth,stage.stageHeight);
			b.fillRect(rect, 0x000000);
			removeChild(img);
			loadImage();
		}
		
		private function enterHandler(e:Event):void
		{
			// Array utilisé pour faire boujer les layers à l'intérieur du Perlin Noise
			offsets[0].x += offsetSpeed1 + (stage.stageWidth/3 - mouseX) / 400;
			offsets[0].y += offsetSpeed1 + (stage.stageHeight/3 - mouseY) / 400;
			offsets[1].x += offsetSpeed2;
			offsets[1].y += offsetSpeed2;
			
			// Ajout du Perlin noise sur un BitmapData
			noiseBMD.perlinNoise( baseX, baseY, 1, noiseSeed, false, true, 70, true, offsets );
			
			this.graphics.clear();
			i=0;
			while(++i<700){
				if(!o[i]){
					o[i] = [mouseX ,mouseY];
				}
				
				// reprend la couleur du pixel du BitmapData "image" pour la couleur des verts
				pixel = toCopy.getPixel(o[i][0], o[i][1]);
				// reprend la couleur du pixel du BitmapData "PerlinNoise" pour le comportement des verts
				pixelDirect = noiseBMD.getPixel(o[i][0], o[i][1]);
				
				brightness = pixelDirect / 0xFFFFFF;
				speed = 0.1 + brightness * 2 ;
				angle = 360 * brightness * 16;
				radians = angle * Math.PI / 180;
				
				this.graphics.lineStyle(1,pixel);
				this.graphics.moveTo(o[i][0],o[i][1]);
				// comportement des verts...
				this.graphics.lineTo(o[i][0]+=Math.cos(radians) * speed * Math.random()*6, o[i][1]+=Math.sin(radians) * speed * Math.random()*6);
				
				
				
				// retour de l'autre côté de la scène
				if(o[i][0] > stage.stageWidth - margin){
					o[i] = [margin ,o[i][1]];
				}
				
				if(o[i][0] < margin){
					o[i] = [stage.stageWidth - margin ,o[i][1]];
				}
				
				if(o[i][1] > stage.stageHeight - margin){
					o[i] = [o[i][0], margin];
				}
				
				if(o[i][1] < margin){
					o[i] = [o[i][0] , stage.stageHeight - margin];
				}
				
			}
			b.draw(this);
		}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			removeEventListener(Event.ENTER_FRAME,enterHandler);
			this.graphics.clear();
			while(numChildren>0){
				removeChildAt(0);
			}
			addedHandler(null);
		}
	}
}